<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
require_once(JPATH_ADMINISTRATOR.'/components/com_amazons3/helpers/amazons3api.php');
require_once(JPATH_ADMINISTRATOR.'/components/com_amazons3/helpers/amazons3.php');
jimport('joomla.filter.input');


class Amazons3ControllerBucket extends JControllerLegacy
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask('apply', 'save');
		$this->registerTask('save2copy', 'save');
		
	}
	
	function display($cachable = false, $urlparams = false) 
	{
        $jinput = JFactory::getApplication()->input;		
		$jinput->set( 'view', 'buckets');
		parent::display();
	}
	
	function add()
	{
		

        $jinput = JFactory::getApplication()->input;		
		$jinput->set( 'view', 'bucket');
		$jinput->set('layout', 'create');
		parent::display();
	}
	
	function save()
	{
		
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		JSession::checkToken() or jexit( 'Invalid Token' );	
		
		$params = AmazonS3Helper::getParams();
		
		$app = JFactory::getApplication();
		$jinput = $app->input;
		$formdata	= $jinput->get('jform', array(),'array');
		
		
		$inputFilter = JFilterInput::getInstance();
		$bucketName = $inputFilter->clean($formdata["bucketName"],"cmd");
		$bucketName = AmazonS3Helper::filterBucketName($bucketName);
		if(empty($bucketName))
		{
			$app->enqueueMessage('The bucket name is empty','error');
			$app->redirect("index.php?option=com_amazons3&view=buckets");

			return;
		}
		
		$region = $inputFilter->clean($formdata["region"],"cmd");
		
		if(empty($region))
		{
			$region = $params->get("defaultRegion","us-east-1");			
		}
		
		$acl = $inputFilter->clean($formdata["cannedACL"],"cmd");
		
		if(empty($acl))
		{
			$acl = $params->get("cannedACL","private");			
		}
		
		
		if(! AmazonS3APIHelper::createBucket($params, $bucketName, $region, $acl))
		{
			$msg = AmazonS3APIHelper::getErrorMessage();
			$app->enqueueMessage($msg,'error');
		}
		else
		{
			$msg = JText::_('AMAZONS3_BUCKET_CREATED');
			$app->enqueueMessage($msg,'message');
		}
		$task = $this->getTask();
        if($task == 'save')
		{
			$app->redirect("index.php?option=com_amazons3&view=buckets");
		}
		else
		{			
			$app->redirect("index.php?option=com_amazons3&view=bucket&task=bucket.add");
		}
		
	}
	
	function cancel()
	{

		$app = JFactory::getApplication();
		$app->enqueueMessage(JText::_("AS3_CREATEBUCKETCANCELLED"),"notice");
		$app->redirect("index.php?option=com_amazons3&view=buckets");
				
	}
	
	function delete()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.delete')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
		$params = AmazonS3Helper::getParams();

        $jinput = JFactory::getApplication()->input;			
		$names = $jinput->get('cid',array(),'array');
		
		$inputFilter = JFilterInput::getInstance();
		$count = 0;

		if (count($names)) {
			foreach($names as $name) {
				$bucketName = $inputFilter->clean($name,"cmd");
				if(AmazonS3APIHelper::deleteBucket($params, $bucketName))
				{
					$count++;
				}
								
			}
		}

		$app = JFactory::getApplication();

		if($count == 0)
		{
			    $msg = JText::_("AMAZONS3_NOBUCKETSERROR");
				$app->enqueueMessage($msg,'error');
		}
		else
		{
			
			    $msg = $count. " " . JText::_("AMAZONS3_BUCKETSDELETED");
				$app->enqueueMessage($msg,'message');
			
		}
		$app->redirect("index.php?option=com_amazons3&view=buckets");
		

	}

	
	
}


?>