<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filter.input');

JLoader::register('AmazonS3Helper', JPATH_COMPONENT_ADMINISTRATOR.'/helpers/amazons3.php');
JLoader::register('DropboxHelper', JPATH_COMPONENT_ADMINISTRATOR.'/helpers/dropbox.php');
JLoader::register('DropboxapiHelper', JPATH_COMPONENT_ADMINISTRATOR.'/helpers/dropboxapi.php');


class Amazons3ControllerDropbox extends JControllerLegacy
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask('uploadNew','upload');
		
	}
	
	function display($cachable = false, $urlparams = false) 
	{
        $jinput = JFactory::getApplication()->input;		
		$jinput->set( 'view', 'dropbox');
		parent::display();
	}
	
	public function form()
	{
		//task to display upload form
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		$view   = $this->getView("dropboxfile","html");
		$view->setLayout("form");
		$view->display();
	}
	
	public function importform()
	{
		//task to display import form
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		$view   = $this->getView("dropboximport","html");
		$view->setLayout("form");
		$view->display();
	}
	
	
	public function upload()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$app = JFactory::getApplication();

		
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
		$params = AmazonS3Helper::getParams(DROPBOX_KEY_ID);
		
		$token = DropboxHelper::getToken($params);
		if(empty($token))
		{
			$errorMessage = JText::_('ASC_DROPBOX_TOKEN_NOT_SET');
			$app->enqueueMessage($errorMessage,'error');
			$app->redirect(JRoute::_('index.php'));
			return;
		}
		
		
        $jinput = JFactory::getApplication()->input;			
		$path = $jinput->get("path","","string");		
		$inputFilter = JFilterInput::getInstance();
		$path = $inputFilter->clean($path);
		
		$formdata = $jinput->get('jform', array(),'array');		
		$options = array();
		$options["mode"] = "add";
		$options["autorename"] = true;
		if($formdata["existing_file"] == "overwrite")
		{
			$options["mode"] = "overwrite";
			$options["autorename"] = false;			
		}
		
		$options["mute"] = (bool)$formdata["mute"];
		
		$allowedExtensions = AmazonS3Helper::getAllowedExtensions($params);
		$files = $jinput->files->get('jform');
		$file = $files['file_to_upload'];
		if(!empty($file["name"]))
		{
			$filename = $inputFilter->clean($formdata["filename"]);
			if(!empty($filename))
			{
				$dest = $filename;
			}
			else
			{
				$dest = basename($file["name"]);
			}
			
			$dest = JFile::makeSafe($dest);
			$dest = str_replace(' ', '-', $dest);
			
			if(!AmazonS3Helper::testExtension($dest, $allowedExtensions))
			{
				$msg = JText::_('AS3_EXTENSIONNOTALLOWED');
				$app->enqueueMessage($msg,'error');
				
			}
			else
			{
				$src = $file['tmp_name'];
				$dest = $path."/".$dest;
				$dest = JPath::clean($dest);
				$options["path"] = $dest;
								
				if($return = DropboxAPIHelper::filesUpload($token, $src, $options))
				{
					$msg = JText::_('AS3_FILEUPLOADSUCCESS').' '.htmlspecialchars($dest);
					$app->enqueueMessage($msg,"message");
				}
				
				
				
			}


		}
		
		$task = $this->getTask();
		if($task == "uploadNew")
		{
			$app->redirect("index.php?option=com_amazons3&view=dropboxfile&layout=form&path=".$path);
			
		}
		else
		{
			$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
		}
		
		
	}
	
	public function cancel()
	{

        $jinput = JFactory::getApplication()->input;			
		$path = $jinput->get("path","","string");		
		$inputFilter = JFilterInput::getInstance();
		$path = $inputFilter->clean($path);

		$app = JFactory::getApplication();
		$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
		
	}
	
	public function delete()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.delete')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$app = JFactory::getApplication();
		

		
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
		$params = AmazonS3Helper::getParams(DROPBOX_KEY_ID);
		
		$token = DropboxHelper::getToken($params);
		if(empty($token))
		{
			$errorMessage = JText::_('ASC_DROPBOX_TOKEN_NOT_SET');
			$app->enqueueMessage($errorMessage,'error');
			$app->redirect(JRoute::_('index.php'));
			return;
		}
		
        $jinput = JFactory::getApplication()->input;			
		$path = $jinput->get("path","","string");		
		$inputFilter = JFilterInput::getInstance();
		$path = $inputFilter->clean($path);
		
		
		$options = array();				
		$entries = $jinput->get('cid',array(),'array');
		if(count($entries) == 1)
		{
			$entry_array = explode(":", $entries[0]);
			if(isset($entry_array[1]) && !empty($entry_array[1]))
			{
				$options["path"] = $inputFilter->clean($entry_array[1],"string");
			}
			else
			{
				$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
				return;
			}
			
			
			if($returnJSON = DropboxAPIHelper::filesDelete($token, $options))
			{
				$result = json_decode($returnJSON);
				$msg = JText::_('AMAZONS3_DROPBOX_SUCCESSFULLY_DELETED').$result->path_display;
				$app->enqueueMessage($msg,'message');
				$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
				return;
				
			}
			else
			{
				$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
				return;
				
			}
		}
		elseif(count($entries) > 1)
		{
			$options["entries"] = array();
			
			foreach($entries as $entry)
			{
				$entry_array = explode(":", $entry);
				if(isset($entry_array[1]) && !empty($entry_array[1]))
				{
					$opt = new stdClass();
					$opt->path =  $inputFilter->clean($entry_array[1],"string");
					$options["entries"][] = $opt;
					
				}
				else
				{
					$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
					return;
				}
				
				
			}
			
			if($returnJSON = DropboxAPIHelper::filesDeleteBatch($token, $options))
			{
				$result = json_decode($returnJSON);
				
				$deleted = " ";
				if($result->{".tag"} == "complete")
				{
					foreach($result->entries as $entry)
					{
						$deleted = $deleted . $entry->metadata->path_display . ', ';
					}
				}
				elseif($result->{".tag"} == "async_job_id")
				{
					//wait a couple of seconds then check status
					sleep(3);
					$newOptions = array("async_job_id" => $result->async_job_id);
					if($checkResultJSON = DropboxAPIHelper::filesDeleteBatchCheck($token, $newOptions))
					{
						$checkResult = json_decode($checkResultJSON);
					}
					if($checkResult->{".tag"} == "complete")
					{
						foreach($checkResult->entries as $entry)
						{
							$deleted = $deleted . $entry->metadata->path_display . ', ';
						}
					}
					else
					{
						$deleted = $deleted . " ". JText::_('AMAZONS3_DROPBOX_WILL_RUN_ASYNC');
					}
					
				}
				$msg = JText::_('AMAZONS3_DROPBOX_SUCCESSFULLY_DELETED').$deleted;
				$app->enqueueMessage($msg,'message');
				$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
				return;
				
			}
			else
			{
				$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
				return;
				
			}
			
			
		}
		
		$app->redirect("index.php?option=com_amazons3&view=dropbox&path=".$path);
		return;
		

		
	}
	
	
	public function connect()
	{
		JSession::checkToken() or die('Invalid Token');
		if (!JFactory::getUser()->authorise('core.admin', 'com_amazons3')) 
		{
			$msg = JText::_( 'AS3_MSG_ADMIN_PASS_ERROR' );
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link, $msg);
			return;			

		}	
		//we have got the dropbox code obtained by the user in the authorization process, now need to swap it for a token which we then store
		$jinput = JFactory::getApplication()->input;	
		$auth_code = $jinput->post->get("auth_code","");
		$params = AmazonS3Helper::getParams(DROPBOX_KEY_ID); //the dropbox credentials always have an id of 2
		if(!DropboxapiHelper::keyCheck($params))
		{
			$msg = JText::_('AS3_DROPKEY_NOT_SET');
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link, $msg);
			return;			
			
		}
		
		//get the token
		$response = DropboxapiHelper::oauth2Token($params, $auth_code);
		if($response)
		{
			//the request was successful so save the response
			$model = $this->getModel('amazons3'); //we use a common model for saving keys and tokens, it is designed to be quite general
			if ($model->storeExtraData($response, true)) {
				$msg = JText::_( 'AS3_MSG_DROPBOX_TOKEN_STORED' );
				$link = 'index.php?option=com_amazons3&view=amazons3';
				$this->setRedirect($link, $msg);
			}
			else {
				JError::raiseWarning(100, JText::_('AS3_MSG_DROPBOX_TOKEN_ERROR').$model->getError());
				$link = 'index.php?option=com_amazons3&view=amazons3';
				$this->setRedirect($link);
			}
			
			
		}
		else
		{
				$link = 'index.php?option=com_amazons3&view=amazons3';
				$this->setRedirect($link);
			
		}

		
	}
	
	public function disconnect()
	{
		JSession::checkToken('get') or die('Invalid Token');
		if (!JFactory::getUser()->authorise('core.admin', 'com_amazons3')) 
		{
			$msg = JText::_( 'AS3_MSG_ADMIN_PASS_ERROR' );
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link, $msg);
			return;			

		}
		
		$params = AmazonS3Helper::getParams(DROPBOX_KEY_ID); //the dropbox credentials always have an id of 2
		$token = DropboxHelper::getToken($params); //if the token is empty we are not yet connected to dropbox, so the connection must be set up first
		if(empty($token))
		{
				//no sense in doing anything further
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link);
			return;			
		}
		
		
		DropboxapiHelper::authTokenRevoke($token);
		
		$app = JFactory::getApplication();
		$input = $app->input;
		$input->set("id",DROPBOX_KEY_ID);
		
		$model = $this->getModel('amazons3'); //we use a common model for saving keys and tokens, it is designed to be quite general
		$model->storeExtraData("", true); //empty the token from db
		
		
		
		$link = 'index.php?option=com_amazons3&view=amazons3';
		$this->setRedirect($link);
		
	}
	
	public function saveToken()
	{
		//store secret token in database
		// get the model
		$model = $this->getModel('amazons3'); //we use a common model for saving keys and tokens, it is designed to be quite general
		
		//check administrator password
		if(! $model->checkAdmin())
		{
			$msg = JText::_( 'AS3_MSG_ADMIN_PASS_ERROR' );
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link, $msg);
			return;
		}
		
		$jinput = JFactory::getApplication()->input;	
		$access_token = $jinput->post->get("dropbox_token","");
		$data = new stdClass();
		$data->access_token = $access_token;
		$encoded_data = json_encode($data);

		
		if ($model->storeExtraData($encoded_data, true)) {
			$msg = JText::_( 'AS3_MSG_DROPBOX_TOKEN_STORED' );
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link, $msg);
		}
		else {
			JError::raiseWarning(100, JText::_('AS3_MSG_DROPBOX_TOKEN_ERROR').$model->getError());
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$this->setRedirect($link);
		}
		
		
	}
	
	public function import()
	{
		JSession::checkToken('post') or jexit('Invalid Token');
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$jinput = JFactory::getApplication()->input;	
		$path = $jinput->get("path","","string");		
		$inputFilter = JFilterInput::getInstance();
		$path = $inputFilter->clean($path);
		$msg = "";
		
		
		$params = AmazonS3Helper::getParams(DROPBOX_KEY_ID); //the dropbox credentials always have an id of 2
		$token = DropboxHelper::getToken($params); //if the token is empty we are not yet connected to dropbox, so the connection must be set up first
		if(empty($token))
		{
				//no sense in doing anything further
			$link = 'index.php?option=com_amazons3&view=amazons3';
			$msg = JText::_('ASC_DROPBOX_TOKEN_NOT_SET');
			$this->setRedirect($link, $msg);
			return;			
		}
		
		$importList = $jinput->get("importList", "", "string");
		$cids = explode(",", $importList);
		//$cids  = $this->input->post->get('cid', array(), 'array');
		$data = $jinput->get('jform', array(),'array');		
		$includeExisting = (bool)$data["includeExisting"];
		$count = 0;
		$skipCount = 0;
		
		if(count($cids))
		{
			foreach($cids as $cid)
			{
				$entry_array = explode(":", $cid);
				if(isset($entry_array[1]) && !empty($entry_array[1]) && $entry_array[0] == "file")
				{
					
				    $filepath = $entry_array[1];
					
					if(!$includeExisting && DropboxHelper::checkFileExists($filepath))
					{
						$skipCount++;
						continue;
					}
					else
					{
						if(DropboxHelper::makeNewFile($filepath))
						{
							$count++;
						}
					}
				}
			}
			$msg = $count . ' ' . JText::_('AS3_MSG_DROPBOX_FILES_IMPORTED').' '.$skipCount.' '. JText::_('AS3_MSG_DROPBOX_FILES_SKIPPED');
			
		}
		else
		{
			$msg = JText::_('AS3_MSG_DROPBOX_NO_FILES_SELECTED');
		}
		
		$link = 'index.php?option=com_amazons3&view=dropbox&path='.$path;
		$this->setRedirect($link, $msg);
		return;			
		
	}



}
?>