<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filter.input');

require_once(JPATH_ADMINISTRATOR.'/components/com_amazons3/helpers/amazons3api.php');
require_once(JPATH_ADMINISTRATOR.'/components/com_amazons3/helpers/amazons3.php');



class Amazons3ControllerObject extends JControllerLegacy
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask('uploadNew','upload');
		
	}
	
	function display($cachable = false, $urlparams = false) 
	{
        $jinput = JFactory::getApplication()->input;		
		$jinput->set( 'view', 'objects');
		parent::display();
	}
	
	function delete()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.delete')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
		$params = AmazonS3Helper::getParams();

        $jinput = JFactory::getApplication()->input;			
		$names = $jinput->get('cid',array(),'array');
		$bucket = $jinput->get("bucket","","cmd");
		
		$inputFilter = JFilterInput::getInstance();
		$count = 0;
		$objects = array();

		if (count($names)) {
			foreach($names as &$name) {
				$name = $inputFilter->clean($name,"string");	
				$objects[] = array('Key'=>$name);
			}
			if(AmazonS3APIHelper::deleteObjects($params, $bucket, $objects))
			{
				$count++;
			}

		}

		$app = JFactory::getApplication();

		if($count == 0)
		{
			    $msg = JText::_("AMAZONS3_NOOBJECTSSERROR");
				$app->enqueueMessage($msg,'error');
		}
		else
		{
			
			    $msg = $count. " " . JText::_("AMAZONS3_OBJECTSDELETED");
				$app->enqueueMessage($msg,'message');
			
		}
		$app->redirect("index.php?option=com_amazons3&view=objects&bucket=".$bucket);
		

	}
	
	function form()
	{
		//task to display upload form
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		$view   = $this->getView("object","html");
		$view->setLayout("form");
		$view->display();
	}
	
	function importform()
	{
		//task to display upload form
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		$view   = $this->getView("objectimport","html");
		$view->setLayout("form");
		$view->display();
	}
	
	function import()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
        $jinput = JFactory::getApplication()->input;			
		$bucket = $jinput->get("bucket","","cmd");		

		$importList = $jinput->get("importList", "", "string");
		$cids = explode(",", $importList);
		$data = $jinput->get('jform', array(),'array');				
		$includeExisting = (bool)$data["includeExisting"];
		
		$count = 0;
		$skipCount = 0;
		
		if(count($cids))
		{
			foreach($cids as $cid)
			{
				if(!empty($cid))
				{
					
				    $filepath = $cid;
					
					if(!$includeExisting && Amazons3Helper::checkFileExists($cid, $bucket))
					{
						$skipCount++;
						continue;
					}
					else
					{
						if(Amazons3Helper::makeNewFile($cid, $bucket))
						{
							$count++;
						}
					}
				}
			}
			$msg = $count . ' ' . JText::_('AS3_MSG_AMAZONS3_FILES_IMPORTED').' '.$skipCount.' '. JText::_('AS3_MSG_AMAZONS3_FILES_SKIPPED');
			
		}
		else
		{
			$msg = JText::_('AS3_MSG_AMAZONS3_NO_FILES_SELECTED');
		}
		
		$link = 'index.php?option=com_amazons3&view=objects&bucket=='.$bucket;
		$this->setRedirect($link, $msg);
		return;			

		
	}
	
	
	function upload()
	{
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$app = JFactory::getApplication();

		
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );	
		$params = AmazonS3Helper::getParams();
        $jinput = JFactory::getApplication()->input;			
		$bucket = $jinput->get("bucket","","cmd");		
		$inputFilter = JFilterInput::getInstance();
		$formdata = $jinput->get('jform', array(),'array');

		
		$allowedExtensions = AmazonS3Helper::getAllowedExtensions($params);
				
		$files = $jinput->files->get('jform');
		$file = $files['file_to_upload'];
		if(!empty($file["name"]))
		{
			$filename = $inputFilter->clean($formdata["filename"]);
			if(!empty($filename))
			{
				$dest = $filename;
			}
			else
			{
				$dest = basename($file["name"]);
			}
			
			$dest = JFile::makeSafe($dest);
			$dest = str_replace(' ', '-', $dest);
			
			if(!AmazonS3Helper::testExtension($dest, $allowedExtensions))
			{
				$msg = JText::_('AS3_EXTENSIONNOTALLOWED');
				$app->enqueueMessage($msg,'error');
				
			}
			else
			{
				$src = $file['tmp_name'];
				$prefix = $inputFilter->clean($formdata["prefix"]);
				$dest = $prefix.$dest;
				$dest = JPath::clean($dest);
								
				if(!AmazonS3APIHelper::upload($params, $bucket, $dest, $src))
				{
					$msg = AmazonS3APIHelper::getErrorMessage();
					$app->enqueueMessage($msg,'error');
				}
				else
				{
					$msg = JText::_('AS3_FILEUPLOADSUCCESS').' '.$dest;
					$app->enqueueMessage($msg,"message");
				}
			}

			
		}
		
		$task = $this->getTask();
		if($task == "uploadNew")
		{
			$app->redirect("index.php?option=com_amazons3&view=object&layout=form&bucket=".$bucket);
			
		}
		else
		{
			$app->redirect("index.php?option=com_amazons3&view=objects&bucket=".$bucket);
		}

	}
	
	public function cancel()
	{

        $jinput = JFactory::getApplication()->input;			
		$bucket = $jinput->get("bucket","","cmd");		

		$app = JFactory::getApplication();
		$app->redirect("index.php?option=com_amazons3&view=objects&bucket=".$bucket);
		
	}
	
	
	
}


?>