<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

/**
 * Package item controller class.
 *
 * @package     Amazons3
 * @subpackage  Controllers
 */
class Amazons3ControllerOrderitem extends JControllerForm
{
	/**
	 * The URL view item variable.
	 *
	 * @var    string
	 * @since  12.2
	 */
	protected $view_item = 'orderitem';

	/**
	 * The URL view list variable.
	 *
	 * @var    string
	 * @since  12.2
	 */
	protected $view_list = 'orderitems';

	/**
	 * Method override to check if you can add a new record.
	 *
	 * @param   array  $data  An array of input data.
	 *
	 * @return  boolean
	 *
	 * @since   1.6
	 */
	protected function allowAdd($data = array())
	{
		$user       = JFactory::getUser();
		return $user->authorise('core.create', 'com_amazons3.order');


		//return parent::allowAdd();
	}
	
	/**
	 * Method override to check if you can edit an existing record.
	 *
	 * @param   array   $data  An array of input data.
	 * @param   string  $key   The name of the key for the primary key; default is id.
	 *
	 * @return  boolean
	 *
	 * @since   1.6
	 */
	protected function allowEdit($data = array(), $key = 'id')
	{
		$recordId = (int) isset($data[$key]) ? $data[$key] : 0;
		$user     = JFactory::getUser();
		$userId   = $user->get('id');
		$asset    = 'com_amazons3.order.' . $recordId;

		// Check general edit permission first.
		if ($user->authorise('core.edit', $asset))
		{
			return true;
		}


		// Since there is no asset tracking, revert to the component permissions.
		return parent::allowEdit($data, $key);
	}
	
	
	public function loadhistory()
	{
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		return parent::loadhistory();
		
	}
	
	public function add()
	{
			$app = JFactory::getApplication();		
			$order_id = $app->input->get("order_id",0,"int");
			$this->view_item = $this->view_item ."&order_id=".$order_id;
			parent::add();
		
	}
	
	
	/**
	 * Method to run batch operations.
	 *
	 * @param   object  $model  The model.
	 *
	 * @return  boolean   True if successful, false otherwise and internal error is set.
	 *
	 * @since   2.5
	 */
	public function batch($model = null)
	{
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		// Set the model
		$model = $this->getModel('Orderitem', 'Amazons3Model', array());

		// Preset the redirect
		$this->setRedirect(JRoute::_('index.php?option=com_amazons3&view=orderitemss' . $this->getRedirectToListAppend(), false));

		return parent::batch($model);
	}
}
?>