<?php
/**
 * @copyright	Copyright (C) 2015 Spiral Scripts. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

abstract class DropboxHelper
{
	public static $token;
	
	public static function getToken($params)
	{
		
		if(isset(self::$token))
		{
			
			return self::$token;
		}
		
		$data = $params->get("key_encrypted_data","");
		if(!empty($data))
		{
			$clientData = json_decode($data);
			if(isset($clientData->access_token) && !empty($clientData->access_token))
			{
				self::$token = $clientData->access_token;
				
				return self::$token;
			}
		}
		
		return false;
		
		
		
	}
 
    public static function checkFileExists($filePath)
	{
		$searchString = addcslashes('"path_display":"'.$filePath.'"','\\"/');
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('id'))->from($db->quoteName('#__amazons3_packages_files'));
		$query->where($db->quoteName('source') . ' = ' . $db->quote('dropbox'));
		$query->where($db->quoteName('params').' LIKE '.$db->quote('%' . $db->escape($searchString).'%'));
		try{
			$db->setQuery($query);
			if($result = $db->loadResult())
			{
				return true;
			}
			else
			{
				return false;
			}
		} catch(Exception $e){return false;}
	}
	
	public static function makeNewFile($filePath)
	{
		JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_amazons3/tables/');		
		JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_amazons3/models/', 'Amazons3');
		$model = JModelLegacy::getInstance('File', 'Amazons3Model', array('ignore_request' => true));
        $jinput = JFactory::getApplication()->input;	
		
		$data = $jinput->get('jform', array(),'array');		
		$data["id"] = 0;
		$data["title"] = basename($filePath);
		$data["source"] = "dropbox";
		
		$params = array();
		$params["location"] = '{"bucket":"","object":""}';	
		$params["downloadType"] = $data["downloadType"];
		$dlocation = new stdClass();
		$dlocation->name = basename($filePath);
		$dlocation->path_display = $filePath;
		$params["dlocation"] = json_encode($dlocation);
		$data["params"] = $params;
		
		if($model->save($data))
		{
		
			return true;
		}
		else
		{
			return false;
		}
	}




}

?>