<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.helper' );


class Amazons3ViewAmazons3 extends JViewLegacy
{
	function display($tpl = null){

		JToolBarHelper::title(   JText::_( 'AS3 Manager' ), 'generic.png' );
		// Options button.
		if (JFactory::getUser()->authorise('core.admin', 'com_amazons3')) 
		{
			JToolBarHelper::preferences('com_amazons3', 400, 570);
		
			$this->loadHelper('Amazons3'); 
			//Amazons3Helper::addSubmenu('amazons3');
			Amazons3Helper::addSidebar('amazons3');
			
			// We don't need toolbar in the modal window.
			if ($this->getLayout() !== 'modal')
			{
				$this->addToolbar();
				$this->sidebar = JHtmlSidebar::render();
			}
			
	
			
			$params	= JComponentHelper::getParams( 'com_amazons3' );
			
			$blankrow = new stdClass();
			$blankrow->secretkey = "";
			$blankrow->publickey = "";
			$blankrow->data = "";
			$blankrow->encrypted_data = "";
			
			$this->availableHosts = $params->get("availableHosts",array("all"));
			
			
			
			$this->params = $params;
			
			if(in_array("all", $this->availableHosts) || in_array("amazons3", $this->availableHosts))
			{				
				$as3key = $this->get("keys");
				if($as3key && !empty($as3key->publickey) && !empty($as3key->secretkey))
				{
					$this->keyText = JText::_('AS3_SECRETKEYSET');
				}
				else
				{
					$this->keyText = JText::_('AS3_SECRETKEYNOTSET');
				}
				if(!$as3key)
				{
					$as3key = clone $blankrow;
				}
				$this->as3key = $as3key;
				
			}
			
			if(in_array("all", $this->availableHosts) || in_array("dropbox", $this->availableHosts))
			{				
				$dropkey = AmazonS3Helper::getKeys(DROPBOX_KEY_ID);
				if(!$dropkey)
				{
					$dropkey = clone $blankrow;
				}
				$this->dropBox = new stdClass();
				$this->dropBox->connectionStatus = 0; //use this to store dropbox connection status
				if($dropkey && !empty($dropkey->publickey) && !empty($dropkey->secretkey))
				{
					$this->dropBox->dropKeyText = JText::_('AS3_DROPKEY_SET');
					$this->dropBox->connectionStatus = 1; //we are ready to connect but maybe not yet conncected
				}
				else
				{
					$this->dropBox->dropKeyText = JText::_('AS3_DROPKEY_NOT_SET');
	
					
				}
				$this->dropBox->dropkey = $dropkey;
				
				//are we connected to dropbox? if we are there will be encrypted extra data with token
				if(!empty($this->dropBox->dropkey->encrypted_data))
				{
					$this->dropBox->clientData = json_decode($this->dropBox->dropkey->encrypted_data);
					if(isset($this->dropBox->clientData->access_token) && !empty($this->dropBox->clientData->access_token))
					{
						$this->dropBox->connectionStatus = 2; //we have a token so must be connected
					}
				}
				else
				{
					$this->dropBox->clientData = new stdClass();
					$this->dropBox->clientData->access_token = "";
				}
				
			}
			parent::display($tpl);
		
		}
		else
		{
			$this->setLayout("welcome");
			parent::display($tpl);
			
		}

	}
	
	protected function addToolbar()
	{
		
		
		
	}


}
?>