<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.helper' );


class Amazons3ViewBucket extends JViewLegacy
{
	function display($tpl = null){

		JFactory::getApplication()->input->set('hidemainmenu', true);
		JToolBarHelper::title(JText::_('COM_AMAZONS3_AMAZONS3_CREATE_BUCKET'));
		
		$this->loadHelper('AmazonS3'); 
		
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.create')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		$this->params	= AmazonS3Helper::getParams();
		$key = $this->params->get("secret_key", false);
		$public_key = $this->params->get("access_key", false);
		if($key && !empty($key) && !empty($public_key))
		{
			$this->error = false;
			$this->errorMessage = JText::_('AS3_SECRETKEYSET');
		}
		else
		{
			$this->error = true;
			$this->errorMessage = JText::_('AS3_SECRETKEYNOTSET');
			parent::display($tpl);
			return;
		}
		
		
		if (!$canDo->get('core.create')) {
			return;
		}	
		
		$this->form	= $this->getForm();
		

		parent::display($tpl);

	}
	
	public function getForm()
	{
		
		// Get the form.
		JForm::addFormPath(JPATH_COMPONENT . '/models/forms');
		JForm::addFieldPath(JPATH_COMPONENT . '/models/fields');
		$name = 'amazons3.bucket';
		$source = 'bucket';
		$options = array('control' => 'jform', 'load_data' => false);

		try
		{
			$form = JForm::getInstance($name, $source, $options, false, false);
            //$data = array();
			//$this->preprocessForm($form, $data);
			//$form->bind($data);
		}
		catch (Exception $e)
		{
			$this->setError($e->getMessage());

			return false;
		}		
		
		if (empty($form))
		{
			return false;
		}
		return $form;
	}		
		
	

}
?>