<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.helper' );

class Amazons3ViewBuckets extends JViewLegacy
{
	function display($tpl = null){

		JToolBarHelper::title(   JText::_( 'Amazon S3: Buckets' ), 'generic.png' );		
		$this->loadHelper('Amazons3api'); 
		$this->loadHelper('Amazons3'); 
		//Amazons3Helper::addSubmenu('buckets');
		$this->params	= AmazonS3Helper::getParams();
		Amazons3Helper::addSidebar('buckets');
		$this->sidebar = JHtmlSidebar::render();
		
		
		$key = $this->params->get("secret_key", false);
		$public_key = $this->params->get("access_key", false);
		if($key && !empty($key) && !empty($public_key))
		{
			$this->error = false;
			$this->errorMessage = JText::_('AS3_SECRETKEYSET');
		}
		else
		{
			$this->error = true;
			$this->errorMessage = '<a href="index.php?option=com_amazons3&view=amazons3" >'.JText::_('AS3_SECRETKEYNOTSET').'</a>';
			parent::display($tpl);
			return;
		}
		
				
		

		$this->result = AmazonS3APIHelper::listBuckets($this->params);
		if(!$this->result)
		{
			$this->error = true;
			$this->errorMessage = AmazonS3APIHelper::getErrorMessage();
		}
		else
		{
			$this->error = false;
			$this->errorMessage = "";
		}
		
		$this->addToolbar();

		parent::display($tpl);

	}
	
	protected function addToolbar()
	{
		
		$canDo = AmazonS3Helper::getActions();
		$user = JFactory::getUser();
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew('bucket.add');
		}	
		if ($canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList(JText::_('AMAZONS3_AREYOUSURE'), 'bucket.delete', 'JTOOLBAR_DELETE');
			//JToolbarHelper::trash('bucket.delete');

		}
		
	}

}
?>