<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

// necessary libraries
JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('dropdown.init');
JHtml::_('formbehavior.chosen', 'select');

$customOptions = array(
	'searchFieldSelector' => '#filter_search'
);
JHtml::_('searchtools.form', '#adminForm', $customOptions);

?>
<style type="text/css">
  div.modal{width:auto; }
  .modal-body iframe{width:auto; }
</style>
<form action="<?php echo JRoute::_('index.php?option=com_amazons3&view=dropbox&path='.htmlspecialchars($this->path, ENT_QUOTES)); ?>" method="post" name="adminForm" id="adminForm">


<?php if (!empty( $this->sidebar)) : ?>
	<!-- sidebar -->
	<div id="j-sidebar-container" class="span2">
		<?php echo $this->sidebar; ?>
	</div>
	<!-- end sidebar -->
	<div id="j-main-container" class="span10">
<?php else : ?>
	<div id="j-main-container">
<?php endif;?>


<?php if(!$this->token)
{
	echo JText::_('ASC_DROPBOX_TOKEN_NOT_SET');    
    echo '<a href="index.php?option=com_amazons3&view=amazons3" class="btn">'.JText::_('ASC_DROPBOX_SETUP_CONFIG') .'</a>';
    
	
}
else
{
?>
    
<div class="js-stools clearfix">
	<div class="clearfix">
		<div class="js-stools-container-bar">
		<label for="filter_search" class="element-invisible">
			<?php echo JText::_('JSEARCH_FILTER'); ?>
		</label>
		<div class="btn-wrapper input-append">
			<input type="text" name="filter_search" id="filter_search" value="<?php echo htmlspecialchars($this->filter_search, ENT_QUOTES); ?>" />
			<button type="submit" class="btn hasTooltip" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_SUBMIT'); ?>">
				<span class="icon-search"></span>
			</button>
		</div>
		<div class="btn-wrapper">
			<button type="button" class="btn hasTooltip js-stools-btn-clear" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_CLEAR'); ?>">
				<?php echo JText::_('JSEARCH_FILTER_CLEAR');?>
			</button>
		</div>
       </div>
    </div>
</div>    
    
	<table class="table table-striped" id="dropboxfilesList">
		<thead>
			<tr>
				<th width="40">
					<input type="checkbox" name="checkall-toggle" value="" title="(<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
				</th>            
               <th width="30">
					<?php if(!empty($this->path)): ?>
                        <a href="index.php?option=com_amazons3&view=dropbox&path=<?php echo htmlspecialchars($this->upLevel, ENT_QUOTES); ?>"><span class="icon-folder-2 large-icon"> </span>..</a>
                    <?php endif; ?>
				</th>            
                 <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_NAME'); ?>
                </th>
                <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_PATH'); ?>
                </th>
                 <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_SIZE'); ?>
                </th>
               
			</tr>
		</thead>
        <?php if($this->has_more): ?>
		<tfoot>
          <tr>
            <th colspan="3">&nbsp;
            </th><th><a href="index.php?option=com_amazons3&view=dropbx&cursor=<?php echo htmlspecialchars($this->cursor, ENT_QUOTES); ?>" title="<?php echo JText::_('AS3_DROPBOX_MORE_ENTRIES_AVAILABLE'); ?>"><?php echo JText::_('AS3_DROPBOX_VIEW_MORE'); ?><span class="icon-arrow-right-2 large-icon"> </span></a></th>
          </tr>
        </tfoot>	
        <?php endif; ?>        
		<tbody>
    <?php
	if(count($this->items)): 
		$i = 0;

		foreach($this->items as $entry): ?>
			<tr>
        <td>
           	<?php echo JHTML::_('grid.id', $i, htmlspecialchars($entry->{".tag"} .':'. $entry->path_display, ENT_QUOTES)); ?>
        </td>
		<td>
		  <?php if($entry->{".tag"} == "folder"): ?>
			<span class="icon-folder-2 large-icon"> </span>
		  <?php elseif($entry->{".tag"} == "file"): ?>
            <?php if($entry->isImage): ?>
              <span class="icon-image large-icon"> </span>             
            <?php else: ?>
              <span class="icon-file-2 large-icon"> </span>  
            <?php endif; ?>    
		  <?php endif; ?>
		</td>
		<td>
		  <?php if($entry->{".tag"} == "folder"): ?>
			 <a href="index.php?option=com_amazons3&view=dropbox&path=<?php echo htmlspecialchars($entry->path_display, ENT_QUOTES); ?>"><?php echo htmlspecialchars($entry->name); ?></a>
		  <?php elseif($entry->{".tag"} == "file"): ?>
			 <a href="#dropModal_<?php echo $i; ?>" data-toggle="modal"><?php echo htmlspecialchars($entry->name); ?></a>
             <?php echo JHTML::_('bootstrap.renderModal', 'dropModal_'.$i, array("url"=>JRoute::_('index.php?option=com_amazons3&view=dropboxfile&format=image&type=jpeg&file='.htmlspecialchars($entry->path_display,ENT_QUOTES)),"width"=>"140", "height"=>"160", "modalWidth"=>"160", "modalHeight"=>"180"), ""); ?> 
		  <?php endif; ?>
	
		</td>
		<td>
		 <?php  echo htmlspecialchars($entry->path_display); ?>
		</td>
		<td>
		   <?php if($entry->{".tag"} == "file"): ?>
			  <?php  echo htmlspecialchars($entry->size); ?>      
		   <?php endif; ?>   
		</td>
		</tr>
          <?php $i++; ?>
		<?php endforeach; ?>
       <?php else: ?>
        <tr>
            <td colspan="4"><?php echo JText::_('ASC_DROPBOX_NO_ITEMS_FOUND'); ?></td>
        </tr>
       <?php endif; ?>
    </tbody>
    </table>
    
    
    <?php 
	
	
}

?>
</div>
    <input type="hidden" name="option" value="com_amazons3" />
    <input type="hidden" name="view" value="dropbox" />
    <input type="hidden" name="boxchecked" value="0" />
    <input type="hidden" name="task" value="dropbox.display" />

<?php echo JHTML::_( 'form.token' ); ?>

</form>