<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

// necessary libraries
JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('dropdown.init');
JHtml::_('formbehavior.chosen', 'select');

$input     = JFactory::getApplication()->input;
$function  = JFactory::getApplication()->input->getCmd('function', 'jSelectDropbox');


$customOptions = array(
	'searchFieldSelector' => '#filter_search'
);
JHtml::_('searchtools.form', '#adminForm', $customOptions);

?>
<form action="<?php echo JRoute::_('index.php?option=com_amazons3&view=dropbox&path='.htmlspecialchars($this->path, ENT_QUOTES).'&layout=modal&tmpl=component&function='.$function); ?>" method="post" name="adminForm" id="adminForm">


<div id="j-main-container">


<?php if(!$this->token)
{
	echo JText::_('ASC_DROPBOX_TOKEN_NOT_SET');    
    echo '<a href="index.php?option=com_amazons3&view=amazons3" class="btn">'.JText::_('ASC_DROPBOX_SETUP_CONFIG') .'</a>';
    
	
}
else
{
?>
    
<div class="js-stools clearfix">
	<div class="clearfix">
		<div class="js-stools-container-bar">
		<label for="filter_search" class="element-invisible">
			<?php echo JText::_('JSEARCH_FILTER'); ?>
		</label>
		<div class="btn-wrapper input-append">
			<input type="text" name="filter_search" id="filter_search" value="<?php echo htmlspecialchars($this->filter_search, ENT_QUOTES); ?>" />
			<button type="submit" class="btn hasTooltip" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_SUBMIT'); ?>">
				<span class="icon-search"></span>
			</button>
		</div>
		<div class="btn-wrapper">
			<button type="button" class="btn hasTooltip js-stools-btn-clear" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_CLEAR'); ?>">
				<?php echo JText::_('JSEARCH_FILTER_CLEAR');?>
			</button>
		</div>
       </div>
    </div>
</div>    
    
	<table class="table table-striped" id="dropboxfilesList">
		<thead>
			<tr>
               <th>
					<?php if(!empty($this->path)): ?>
                        <a href="index.php?option=com_amazons3&view=dropbox&path=<?php echo htmlspecialchars($this->upLevel, ENT_QUOTES); ?>"><span class="icon-folder-2 large-icon"> </span>..</a>
                    <?php endif; ?>
				</th>            
                 <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_NAME'); ?>
                </th>
                <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_PATH'); ?>
                </th>
                 <th>
                    <?php echo JText::_('AS3_DROPBOX_OBJECT_SIZE'); ?>
                </th>
               
			</tr>
		</thead>
        <?php if($this->has_more): ?>
		<tfoot>
          <tr>
            <th colspan="3">&nbsp;
            </th><th><a href="index.php?option=com_amazons3&view=dropbx&cursor=<?php echo htmlspecialchars($this->cursor, ENT_QUOTES); ?>" title="<?php echo JText::_('AS3_DROPBOX_MORE_ENTRIES_AVAILABLE'); ?>"><?php echo JText::_('AS3_DROPBOX_VIEW_MORE'); ?><span class="icon-arrow-right-2 large-icon"> </span></a></th>
          </tr>
        </tfoot>	
        <?php endif; ?>        
		<tbody>
    <?php
	if(count($this->items)): 
		foreach($this->items as $entry): ?>
			<tr>
		<td>
		  <?php if($entry->{".tag"} == "folder"): ?>
			<span class="icon-folder-2 large-icon"> </span>
		  <?php elseif($entry->{".tag"} == "file"): ?>
			<span class="icon-file-2 large-icon"> </span>      
		  <?php endif; ?>
		</td>
		<td>
		  <?php if($entry->{".tag"} == "folder"): ?>
			 <a href="index.php?option=com_amazons3&view=dropbox&layout=modal&tmpl=component&function=<?php echo htmlspecialchars($function, ENT_QUOTES);?>&path=<?php echo htmlspecialchars($entry->path_display, ENT_QUOTES); ?>"><?php echo htmlspecialchars($entry->name); ?></a>
		  <?php elseif($entry->{".tag"} == "file"): ?>
             <?php 
			     $returnObj = new stdClass();
				 $returnObj->name = $entry->name;
				 $returnObj->id = $entry->id;
				 $returnObj->path_display = $entry->path_display;
				 $returnVal = json_encode($returnObj);
			 ?>
             <a href="javascript:void(0)" onclick="if (window.parent) window.parent.<?php echo htmlspecialchars($function, ENT_QUOTES);?>('<?php echo htmlspecialchars($returnVal, ENT_QUOTES); ?>', '<?php echo htmlspecialchars($entry->name , ENT_QUOTES); ?>');">
			 <?php echo htmlspecialchars($entry->name); ?>
             </a>
		  <?php endif; ?>
	
		</td>
		<td>
		 <?php  echo htmlspecialchars($entry->path_display); ?>
		</td>
		<td>
		   <?php if($entry->{".tag"} == "file"): ?>
			  <?php  echo htmlspecialchars($entry->size); ?>      
		   <?php endif; ?>   
		</td>
		</tr>
		<?php endforeach; ?>
       <?php else: ?>
        <tr>
            <td colspan="4"><?php echo JText::_('ASC_DROPBOX_NO_ITEMS_FOUND'); ?></td>
        </tr>
       <?php endif; ?>
    </tbody>
    </table>
    
    
    <?php 
	
	
}

?>
</div>
</form>