<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.helper' );

class Amazons3ViewDropbox extends JViewLegacy
{
	public $imageExtensions =  array("jpg", "jpeg", "png", "tiff", "tif", "gif", "bmp");
	
	function display($tpl = null){

		JToolBarHelper::title(   JText::_( 'Dropbox Files' ), 'generic.png' );	
		$this->loadHelper('dropbox'); 		
		$this->loadHelper('dropboxapi'); 
		$this->loadHelper('Amazons3'); 
		Amazons3Helper::addSubmenu('dropbox');
		$this->params	= AmazonS3Helper::getParams(DROPBOX_KEY_ID); //we always use the id of 2 for dropbox params
				
		$this->token = DropboxHelper::getToken($this->params); //if the token is empty we are not yet connected to dropbox, so the connection must be set up first
		$this->response = "";
		$options = array();
		$app = JFactory::getApplication();
		$input = $app->input;
		$this->path = $input->get("path","","string");
		$currentCursor = $input->get("cursor","","string");
		$this->filter_search = $input->get("filter_search","", "string");		
		$this->cursor = ""; //this will hold any new cursor returned by the response
		$this->has_more = false;
		
		
		//do we need button to go back up a level?
		$this->upLevel = "";
		if(!empty($this->path))
		{
			$pos = strrpos($this->path, "/", 1);
			if($pos !== false)
			{
				$this->upLevel = substr($this->path, 0, $pos); //get the substring before the final occurance of '/'
			}
		}
		
		Amazons3Helper::addSidebar('dropbox');
		
		// We don't need toolbar in the modal window.
		if ($this->getLayout() !== 'modal')
		{
			$this->addToolbar();
			$this->sidebar = JHtmlSidebar::render();
		}
		
		if($this->token)
		{
				//use the token to get the files
				if(!empty($currentCursor))
				{
					$options["cursor"] = $currentCursor;					
					$responseJSON = DropboxapiHelper::filesListFolderContinue($this->token, $options);					
				}
				else
				{
					$options["path"] = $this->path;
					if(!empty($this->filter_search))
					{
						$options["query"] = $this->filter_search;
						$responseJSON = DropboxapiHelper::filesSearch($this->token, $options);
					}
					else
					{
						$responseJSON = DropboxapiHelper::filesListFolder($this->token, $options);
					}
				}
				$this->response = json_decode($responseJSON);
				if(isset($this->response->has_more) && $this->response->has_more)
				{
					$this->has_more = true;
					$this->cursor = $this->response->cursor;
				}
				
				$this->items = array();
				
				if(!empty($this->filter_search))
				{
                   if(count($this->response->matches))
				   {
					   foreach($this->response->matches as $match)
					   {
						   $this->items[] = $match->metadata;
					   }
				   }
				   
				   if($this->response->more)
				   {
					   $this->has_more = true;
				   }

				}
				else
				{
					$this->items = $this->response->entries;
				}
				
				foreach($this->items as $entry)
				{
					//check if it is an image
					$entry->isImage = $this->isImage($entry);
				}
		}
		
		
		parent::display($tpl);
		
		
		
	}
	
	protected function isImage($entry)
	{
		
		
		if($entry->{".tag"} == "folder")
		{
			return false;
		}
		elseif($entry->{".tag"} == "file")
		{
			$chunks = explode(".", $entry->name);
			$ext = strtolower(end($chunks));
			if(in_array($ext, $this->imageExtensions))
			{
				return true;
			}
		}
		
		return false;
	}
	
	protected function addToolbar()
	{
		
		$canDo = AmazonS3Helper::getActions();
		$user = JFactory::getUser();
		if ($canDo->get('core.create')) {
			//JToolBarHelper::addNew('object.add');
			$bar = JToolbar::getInstance('toolbar');	
			// Add an upload button.
			$bar->appendButton('Standard', 'upload', 'JTOOLBAR_UPLOAD', 'dropbox.form',false);
			JToolbarHelper::divider();
			
			
		}	
		if ($canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList(JText::_('AMAZONS3_AREYOUSURE_OBJECT'), 'dropbox.delete', 'JTOOLBAR_DELETE');
			JToolbarHelper::divider();
			
		}
		
		if ($canDo->get('core.create')) {
			$bar = JToolbar::getInstance('toolbar');	
			// Add an import button.
			$bar->appendButton('Standard', 'plus-circle', 'AS3_LABEL_IMPORT', 'dropbox.importform',true);
			JToolbarHelper::divider();
						
		}	
		
		
		if ($canDo->get('core.create')) {
			// Instantiate a new JLayoutFile instance and render the layout
			$layout = new JLayoutFile('toolbar.newfolder');
			$bar = JToolbar::getInstance('toolbar');	

			$bar->appendButton('Custom', $layout->render(array()), 'newfolder');
			JToolbarHelper::divider();


		}
		
		
	}
	
	
	
}

?>