<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

if(!$this->error)
{
	if(!version_compare(JVERSION,'3','<')){
		
		JHtml::_('bootstrap.tooltip');
		JHtml::_('behavior.multiselect');
		JHtml::_('dropdown.init');
		JHtml::_('formbehavior.chosen', 'select');
	}
	
	?>
    
    <form action="index.php" method="post" name="adminForm" id="adminForm">
    
		<?php if (!empty( $this->sidebar)) : ?>
            <div id="j-sidebar-container" class="span2">
                <?php echo $this->sidebar; ?>
            </div>
            <div id="j-main-container" class="span10">
        <?php else : ?>
            <div id="j-main-container">
        <?php endif;?>
        
        <?php if(!empty($this->bucket)): ?>
    		<div id="filter-bar" class="btn-toolbar">
                <div class="btn-group pull-left">
                    <label for="bucket" class="element"><?php echo JText::_('Choose Bucket: ');?></label>
                    <select name="bucket" id="bucket" class="input-medium" onchange="this.form.submit();">
                        <option value="">--<?php echo JText::_('Select');?>--</option>
                        <?php echo $this->bucketSelect; ?>
                    </select>  
                                                 
                </div>
                <div class="btn-group pull-right">
                      <br style="clear:both;" />
                      <a class="btn" href="index.php?option=com_amazons3&view=objects&bucket=<?php echo htmlspecialchars($this->bucket,ENT_QUOTES); ?>&prefix=<?php echo $this->prefix; ?>"><i class="icon-first"></i> <?php echo JText::_('AS3_BACKTOSTART'); ?></a>  
                  <?php if(!empty($this->prevmarker)): ?>
                      <a class="btn" href="index.php?option=com_amazons3&view=objects&bucket=<?php echo htmlspecialchars($this->bucket,ENT_QUOTES); ?>&prefix=<?php echo $this->prefix; ?>&marker=<?php echo htmlspecialchars($this->prevmarker,ENT_QUOTES); ?>"><i class="icon-previous"></i> <?php echo JText::_('AS3_PREV'); ?></a>
                  <?php endif; ?>                      
                <?php if($this->result["IsTruncated"]): ?>             
                      <a class="btn" href="index.php?option=com_amazons3&view=objects&bucket=<?php echo htmlspecialchars($this->bucket,ENT_QUOTES); ?>&prefix=<?php echo $this->prefix; ?>&marker=<?php echo htmlspecialchars($this->nextmarker,ENT_QUOTES); ?>&prevmarker=<?php echo htmlspecialchars($this->result["Marker"],ENT_QUOTES); ?>"><i class="icon-next"></i> <?php echo JText::_('AS3_NEXT'); ?></a>
                <?php endif; ?>
                </div>
            
                <div class="btn-group pull-right">
                   <label for="maxKeys" class="element">Maximum Objects to Display: </label>
                   <select name="maxKeys" id="maxKeys" class="input-medium" onchange="this.form.submit();">
                         <option value="10" <?php echo $this->selectedMaxKeys[10]; ?> >10</option>
                         <option value="20" <?php echo $this->selectedMaxKeys[20]; ?>>20</option>
                         <option value="50" <?php echo $this->selectedMaxKeys[50]; ?>>50</option>
                         <option value="100" <?php echo $this->selectedMaxKeys[100]; ?>>100</option>
                         <option value="200" <?php echo $this->selectedMaxKeys[200]; ?> >200</option>
                         <option value="500" <?php echo $this->selectedMaxKeys[500]; ?> >500</option>
                         <option value="1000" <?php echo $this->selectedMaxKeys[1000]; ?> >1000</option>                  
                   </select>
                </div>
                <div class="btn-group pull-right">
                   <label for="prefix" class="element">Choose Prefix: </label>
                   <select name="prefix" id="prefix" class="input-medium" onchange="this.form.submit();">
                     <?php echo JHtml::_('select.options', $this->commonPrefixes, 'value', 'text', $this->prefix);?>
                   </select>
                </div>
                <br style="clear:both" />
            </div>
    
   
    	<table class="adminlist table table-striped" id="articleList">
		<thead>
			<tr>
					
				<th width="20">
					<input type="checkbox" name="checkall-toggle" value="" title="(<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
				</th>
                <th class="title">
                <?php echo JText::_("AS3_OBJECTTITLE"); ?>
                </th>
                <th class="title">
                <?php echo JText::_("AS3_OBJECTMODIFIED"); ?>
                </th>
                <th class="title">
                <?php echo JText::_("AS3_OBJECTETAG"); ?>
                </th>
                <th class="title">
                <?php echo JText::_("AS3_OBJECTSTORAGECLASS"); ?>
                </th>                
                <th class="title">
                <?php echo JText::_("AS3_OBJECTOWNER"); ?>
                </th>
                <th class="title">
                <?php echo JText::_("AS3_OBJECTSIZE"); ?>
                </th>
               
							</tr> 			
		</thead>
		<tfoot>
</tfoot>
	<tbody>

    
    <?
	$i = 0;
	if(count($this->result['Contents']))
	{
		  foreach ($this->result['Contents'] as $object) {
			  if($object['Key'] != $this->prefix)
			  {
				 $checked = JHTML::_('grid.id', $i, $object['Key']);
			  }
			  else
			  {
				  $checked = "";
			  }
			   ?>
				  <tr class="row<?php echo $i % 2; ?>">
								
						  <td><?php echo $checked;  ?></td>
						  <td><?php echo htmlspecialchars($object['Key'],ENT_QUOTES); ?></td>
						  <td><?php echo htmlspecialchars($object['LastModified'],ENT_QUOTES); ?></td>
						  <td><?php echo htmlspecialchars($object['ETag'],ENT_QUOTES); ?></td>
						  <td><?php echo htmlspecialchars($object['StorageClass'],ENT_QUOTES); ?></td>
						  <td><?php if(isset($object['Owner']["DisplayName"])){echo htmlspecialchars($object['Owner']["DisplayName"],ENT_QUOTES); }?></td>
						  <td><?php echo htmlspecialchars($object['Size'],ENT_QUOTES); ?></td>
				  </tr>
	  
	  
			  <?php 
	  
		  } //end foreach
	}
	?>
    </tbody>
    </table>
    <?php else: ?>
    		<div id="filter-bar" class="btn-toolbar">
                <div class="btn-group pull-left">
                    <label for="bucket" class="element"><?php echo JText::_('Choose Bucket');?></label>
                    <select name="bucket" id="bucket" class="input-medium" onchange="this.form.submit();">
                        <option value="">--<?php echo JText::_('Select');?>--</option>
                        <?php echo $this->bucketSelect; ?>
                    </select>  
                                                 
                </div>
             </div> 
             <table class="adminlist table table-striped" id="articleList">
              </table>   
    <?php endif; ?>
    <input type="hidden" name="option" value="com_amazons3" />
    <input type="hidden" name="view" value="objects" />
    <input type="hidden" name="boxchecked" value="0" />
    <input type="hidden" name="task" value="object.display" />

<?php echo JHTML::_( 'form.token' ); ?>
</div>
</form>  	    
    <?php
}
else
{
	echo $this->errorMessage;
}
?>

