<?php
/**
 * @version		1.0.0 as3 file manager $
 * @package		as3 file manager
 * @copyright	Copyright © Inspiration Web Design http://www.spiralscripts.co.uk 2016 - All rights reserved.
 * @license		GNU/GPL
 * @author		Fiona Coulter
 * @author mail	joomla - at - iswebdesign.co.uk
 * @website		http://www.spiralscripts.co.uk
 *
 **/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.helper' );


class Amazons3ViewObjects extends JViewLegacy
{
	function display($tpl = null){
		
		
		$this->loadHelper('Amazons3api'); 
		$this->loadHelper('Amazons3'); 
		$this->params = AmazonS3Helper::getParams();
		$layout = $this->getLayout();
		
		
		$key = $this->params->get("secret_key", false);
		$public_key = $this->params->get("access_key", false);
		if($key && !empty($key) && !empty($public_key))
		{
			$this->error = false;
			$this->errorMessage = JText::_('AS3_SECRETKEYSET');
		}
		else
		{
			$this->error = true;
			$this->errorMessage = '<a href="index.php?option=com_amazons3&view=amazons3" >'.JText::_('AS3_SECRETKEYNOTSET').'</a>';
			if ($layout != 'modal')
			{
				Amazons3Helper::addSidebar('objects');
			}
			parent::display($tpl);
			return;
		}
		
		
		$app = JFactory::getApplication();
		$jinput = $app->input;
		//$this->bucket = $jinput->get("bucket",null,"cmd");
		$this->bucket = $app->getUserStateFromRequest("amazons3.bucket","bucket",null,"cmd");
		$this->bucketSelect = $this->getBucketSelect($this->bucket);
		
			// We don't need toolbar in the modal window.
		if ($layout != 'modal')
		{
			Amazons3Helper::addSidebar('objects');
			if(!empty($this->bucket))
			{
			  $this->addToolbar();
			}
			$this->sidebar = JHtmlSidebar::render();
			
		}
		else
		{
			
			$this->fn = $jinput->get("function","","cmd");
		}
		
		
		
		if(empty($this->bucket))
		{
			JToolBarHelper::title(JText::_('Amazon S3: Choose a bucket to view its objects '), 'generic.png' );	
			parent::display($tpl);
			return;
			
		}
		JToolBarHelper::title(JText::_('Amazon S3: Objects in Bucket ')." ".$this->bucket, 'generic.png' );	
		

		
		$canDo = AmazonS3Helper::getActions();
		if (!$canDo->get('core.manage')) {
			 return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
		}
		
		
		
		$options = array(); //set up options for listing the objects

		//$maxKeys = $jinput->get("maxKeys",$this->params->get("maxKeys",100),"int");
		$maxKeys = $app->getUserStateFromRequest("amazons3.maxKeys","maxKeys",100);
		if($maxKeys > 0)
		{
			$options["MaxKeys"] = $maxKeys;
		}
		$this->maxKeys = $maxKeys;
		$this->selectedMaxKeys = array(10=>"",20=>"",50=>"",100=>"",200=>"",500=>"",1000=>"");
		$this->selectedMaxKeys[$maxKeys] = 'selected="selected"';
		
		
		$this->marker = $jinput->get("marker","","string");
		if(!empty($this->marker))
		{
			$options["Marker"] = $this->marker;
		}
		
		$this->prevmarker = $jinput->get("prevmarker","","string");
		$this->delimiter = $this->params->get("delimiter","/");
		
		
		$this->prefix = htmlspecialchars($jinput->get("prefix","","string"));

		if(!empty($this->prefix))
		{
			$options["Prefix"] = $this->prefix;
		}
		
		
		
		
		$this->result = AmazonS3APIHelper::listObjects($this->params,$this->bucket, $options);
		if(!$this->result)
		{
			$this->error = true;
			$this->errorMessage = AmazonS3APIHelper::getErrorMessage();
		}
		else if(count($this->result) == 0)
		{
			$this->error = true;
			$this->errorMessage = JText::_('AS3_NORESULTS');
		}
		else
		{
			$this->error = false;
			$this->errorMessage = "";
			
			if(isset($this->result["NextMarker"]))
			{
				$this->nextmarker = $this->result["NextMarker"];
			}
			else
			{
				$contents = $this->result['Contents'];
				if(count($contents))
				{
					$lastContent = end($contents);
					reset($contents);
					$this->nextmarker = $lastContent['Key'];
				}
				else
				{
					$this->nextmarker = "";
				}
			}
			
			$commonPrefixes = AmazonS3APIHelper::getCommonPrefixes($this->params, $this->bucket);
			$this->commonPrefixes = array();
			$this->commonPrefixes[] = JHTML::_('select.option', "", $this->delimiter);
			
			if(isset($commonPrefixes))
			{
				  foreach($commonPrefixes as $commonPrefix)
				  {
					  $prefix = $commonPrefix["Prefix"];
					  $this->commonPrefixes[] = JHTML::_('select.option', $prefix, $prefix);
				  }
			}
		}

		parent::display($tpl);

	}
	
	protected function addToolbar()
	{
		
		$canDo = AmazonS3Helper::getActions();
		$user = JFactory::getUser();
		if ($canDo->get('core.create')) {
			//JToolBarHelper::addNew('object.add');
			$bar = JToolbar::getInstance('toolbar');	
			// Add an upload button.
			$bar->appendButton('Standard', 'upload', 'JTOOLBAR_UPLOAD', 'object.form',false);
			
		}	
		if ($canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList(JText::_('AMAZONS3_AREYOUSURE_OBJECT'), 'object.delete', 'JTOOLBAR_DELETE');
		}
		
		if ($canDo->get('core.create')) {
			$bar = JToolbar::getInstance('toolbar');	
			// Add an import button.
			$bar->appendButton('Standard', 'plus-circle', 'AS3_LABEL_IMPORT', 'object.importform',true);
			JToolbarHelper::divider();
						
		}	
		
		
	}
	
	protected function getBucketSelect($selected = null)
	{
		$this->result = AmazonS3APIHelper::listBuckets($this->params);
		$listOptions = array();
		foreach ($this->result['Buckets'] as $bucket) {
			$bucketName = $bucket['Name'];
			$listOptions[$bucketName] = $bucketName;
		}
		
		$options = JHtml::_('select.options', $listOptions, 'value', 'text', $selected);
		return $options;
		
		
	}

}
?>