<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

require_once JPATH_COMPONENT.'/helpers/amazons3.php';

/**
 * Packages list view class.
 *
 * @package     Amazons3
 * @subpackage  Views
 */
class Amazons3ViewPackages extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;
	
	public function display($tpl = null)
	{
		$this->state		 = $this->getModel()->getState();
		$this->pagination	 = $this->getModel()->getPagination();
		$this->authors		 = $this->getModel()->getAuthors();
		$this->filterForm    = $this->getModel()->getFilterForm();
		$this->activeFilters = $this->getModel()->getActiveFilters();
		$this->user		 	 = JFactory::getUser();
		

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors));
			return false;
		}
		
		if ($this->getLayout() == 'button')
		{
			if ($this->user->authorise('core.edit', "com_amazons3")||$this->user->authorise('core.create', "com_amazons3"))
			{			
				JHTML::_('behavior.framework',true);
				$input = JFactory::getApplication()->input;
				$eName = $input->getCmd('e_name');
				$eName    = preg_replace('#[^A-Z0-9\-\_\[\]]#i', '', $eName);
				
				$this->asset = $input->getCmd('asset');
				$this->author = $input->getCmd('author');
				$this->filesLink = 'index.php?option=com_amazons3&amp;view=files&amp;layout=button&amp;tmpl=component&amp;e_name=' . $eName . '&amp;asset=' . $this->asset . '&amp;author=' . $this->author;
				
				
				$document = JFactory::getDocument();
				$document->setTitle(JText::_('COM_AMAZONS3_BUTTON_DOC_TITLE'));
				
				//$this->state->set("filter.isfree",1);
				$this->items = $this->getModel()->getItems();
				
				$this->eName = &$eName;
				parent::display($tpl);
			}
			return;
		}
		
		$this->items		 = $this->getModel()->getItems();
		Amazons3Helper::addSidebar('packages');
		
		// We don't need toolbar in the modal window.
		if ($this->getLayout() !== 'modal')
		{
			$this->addToolbar();
			$this->sidebar = JHtmlSidebar::render();
		}
		
		parent::display($tpl);
	}
	
	/**
	 *	Method to add a toolbar
	 */
	protected function addToolbar()
	{
		$state	= $this->get('State');
		$canDo	= Amazons3Helper::getActions();
		$user	= JFactory::getUser();
				

		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');
		
		JToolBarHelper::title(JText::_('COM_AMAZONS3_AMAZONS3_PACKAGES_VIEW_PACKAGES_TITLE'));
		
		if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_amazons3', 'core.create'))) > 0 )
		{
			JToolBarHelper::addNew('package.add','JTOOLBAR_NEW');
		}

		if (($canDo->get('core.edit') || $canDo->get('core.edit.own')) && isset($this->items[0]))
		{
			JToolBarHelper::editList('package.edit','JTOOLBAR_EDIT');
		}
		
		if ($canDo->get('core.edit.state'))
		{
            if (isset($this->items[0]->published))
			{
			    JToolBarHelper::divider();
				JToolbarHelper::publish('packages.publish', 'JTOOLBAR_PUBLISH', true);
				JToolbarHelper::unpublish('packages.unpublish', 'JTOOLBAR_UNPUBLISH', true);
            } 
			else if (isset($this->items[0]))
			{
                // Show a direct delete button
                JToolBarHelper::deleteList('', 'packages.delete','JTOOLBAR_DELETE');
            }

            if (isset($this->items[0]->published))
			{
			    JToolBarHelper::divider();
			    JToolBarHelper::archiveList('packages.archive','JTOOLBAR_ARCHIVE');
            }
            
			if (isset($this->items[0]->checked_out))
			{
				JToolbarHelper::checkin('packages.checkin');
            }
		}
		
		// Show trash and delete for components that uses the state field
        if (isset($this->items[0]->published))
		{
		    if ($state->get('filter.published') == -2 && $canDo->get('core.delete'))
			{
			    JToolBarHelper::deleteList('', 'packages.delete','JTOOLBAR_EMPTY_TRASH');
			    JToolBarHelper::divider();
		    }
			else if ($state->get('filter.published') != -2 && $canDo->get('core.edit.state'))
			{
			    JToolBarHelper::trash('packages.trash','JTOOLBAR_TRASH');
			    JToolBarHelper::divider();
		    }
        }
		
		// Add a batch button
		if (isset($this->items[0]) && $user->authorise('core.create', 'com_amazons3') && $user->authorise('core.edit', 'com_amazons3') && $user->authorise('core.edit.state', 'com_amazons3'))
		{
			JHtml::_('bootstrap.modal', 'collapseModal');
			$title = JText::_('JTOOLBAR_BATCH');

			// Instantiate a new JLayoutFile instance and render the batch button
			$layout = new JLayoutFile('joomla.toolbar.batch');

			$dhtml = $layout->render(array('title' => $title));
			$bar->appendButton('Custom', $dhtml, 'batch');
		}
		
		if ($canDo->get('core.admin'))
		{
			JToolBarHelper::preferences('com_amazons3');
		}
	}
}
?>