<?php
/*
copyright 2009 Fiona Coulter http://www.iswebdesign.co.uk

This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


// no direct access
defined('_JEXEC') or die('Restricted access');

class Com_amazons3InstallerScript{
	
	
  public function preflight($type, $parent){
	  
  }
	 
  public function postflight($type, $parent){
	  
  }
  
  public function install($parent)
  {
	    //update the plugins to enable them
	  	$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$plugins = array("as3downloads", "as3");
		$fields = array($db->quoteName("enabled")." = 1");
		
		foreach($plugins as $plugin)
		{
		  try{
			  $query = $db->getQuery(true);
			  $where = $db->quoteName("type")." = 'plugin' AND ".$db->quoteName("element")." = ".$db->quote($plugin);
			  $query->update($db->quoteName('#__extensions'))->set($fields)->where($where);
			  $db->setQuery($query);
			  $result = $db->execute();	
		  } catch(Exception $e){}
			
		}


	  
  }
  
  
  public function update($parent)
  {
	  //does the table need to be updated?
	  $db = JFactory::getDBO();

	  $query = 'SHOW COLUMNS FROM `#__amazons3_config`';
	  $db->setQuery($query);
	  $columns = $db->loadColumn(0);
	  
	  if(!in_array('publickey',$columns))
	  {
	      //we do need to add the public key for amazon s3
		  $this->alterTable("#__amazons3_config", array(
					"keytype" => "`keytype` VARCHAR(255) NOT NULL DEFAULT '' AFTER `id`",
					"publickey" => "`publickey` text NOT NULL DEFAULT '' AFTER `keytype`",
					"data" => "`data` text NOT NULL DEFAULT '' AFTER `secretkey`",
					"encrypted_data" => "`encrypted_data` blob"
				));
		  
				$params = JComponentHelper::getParams('com_amazons3');
				$publickey = $params->get("access_key","");
				
				$query = $db->getQuery(true);
				$query->update($db->quoteName('#__amazons3_config'));
				$query->set(array("`keytype`='as3'","`publickey`=".$db->quote($publickey),"`data`=''","`encrypted_data`=NULL"));
				
				$conditions = array($db->quoteName("id")."=1");
				$query->where($conditions);
				$db->setQuery($query);
				  
				$db->execute();
		  
		  
	  
	  }
  }
  
	/**
	 * Runs on uninstallation
	 *
	 * @param JInstaller $parent
	 */
  public function uninstall($parent){
	  
  }
  
		private function alterTable($tablename,$fields,$command='ADD'){

			$ok = false;
			$db = JFactory::getDBO();

			$query = 'SHOW COLUMNS FROM `'.$tablename.'` ';
			$db->setQuery($query);
			$columns = $db->loadColumn(0);

			foreach($fields as $fieldname => $alterCommand){
			   if($command == "ADD")
			   {
				  if(!in_array($fieldname,$columns)){
					  $query = 'ALTER TABLE `'.$tablename.'` '.$command.' COLUMN '.$alterCommand;
  
					  $db->setQuery($query);
					  if(!$db->execute()){
						  $app = JFactory::getApplication();
						  $app->enqueueMessage('Error: Install alterTable '.$db->getErrorMsg() );
						  $ok = false;
					  }
				  }
			   }
			   else
			   {
				  if(in_array($fieldname,$columns)){
					  $query = 'ALTER TABLE `'.$tablename.'` '.$command.' COLUMN '.$alterCommand;
  
					  $db->setQuery($query);
					  if(!$db->execute()){
						  $app = JFactory::getApplication();
						  $app->enqueueMessage('Error: Install alterTable '.$db->getErrorMsg() );
						  $ok = false;
					  }
				  }
				   
			   }
			}

			return $ok;
		}
  
	

}

?>