<?php
/**
 * @copyright	Copyright (C) 2015 Spiral Scripts. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

abstract class AmazonS3SiteHelper
{
	
	static $keys =  array();
	

	
	public static function getParams($id = 1)
	{
		
		$app = JFactory::getApplication();
		$params = $app->getParams();
		$keys = self::getKeys($id);
		if($keys)
		{
			$params->set("secret_key",$keys->secretkey);
			$params->set("access_key",$keys->publickey);
			$params->set("key_data",$keys->data);
			$params->set("key_encrypted_data",$keys->encrypted_data);		
			$params->set("key_type",$keys->keytype);
		}
		return $params;

		
	}
	
    public static function getKeys($id = 1)
	{
		
		if(isset(self::$keys[$id]))
		{
			return self::$keys[$id];
		}
		$word = self::getSecretWord();	
		$app = JFactory::getApplication();
		$params = $app->getParams();
		$hash = $params->get("hash_type","SHA2");
		$validHashValues = array('SHA1','SHA2','MD5');
		if(!in_array($hash, $validHashValues))
		{
			$hash = "SHA2";
		}
		
		
		
		try{
			$db = JFactory::getDBO();
			$query = $db->getQuery(true);
			
			if($hash == "SHA2")
			{		  
			
			  $query->select(array("keytype","publickey","data","AES_DECRYPT( secretkey, UNHEX(".$hash."(".$db->quote($word).",512))) AS skey", "AES_DECRYPT( encrypted_data, UNHEX(".$hash."(".$db->quote($word).",512))) AS edata"));
			}
			else
			{
			  $query->select(array("keytype","publickey","data","AES_DECRYPT( secretkey, UNHEX(".$hash."(".$db->quote($word)."))) AS skey", "AES_DECRYPT( encrypted_data, UNHEX(".$hash."(".$db->quote($word)."))) AS edata"));				
			}
			$query->from("#__amazons3_config");
			$query->where("id=".(int)$id);
			$db->setQuery( $query );
			$row = $db->loadObject();
					
			if($row)
			{
				$row->secretkey = base64_decode($row->skey);
				$row->encrypted_data = base64_decode($row->edata);				
				self::$keys[$id] = $row;				
				return $row;
			}
			else
			{
				self::$keys[$id] = false;				
				return false;	
			}
		} catch(Exception $e){ return false; }
		
		
	}
	
	
	
	public static function getSecretWord()
	{
		if(class_exists("Amazons3Config"))
		{
			return Amazons3Config::$secret_word;
		}
		$filename = JPATH_ADMINISTRATOR."/components/com_amazons3/config.php";
		if(file_exists($filename))
		{
			require_once($filename);
			return Amazons3Config::$secret_word;
		}
		
		return "";
	}
	
	public static function getBadCats()
	{
		static $badcats;
		if(isset($badcats))
		{
			return $badcats;
		}
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		
		$subquery = ' SELECT cat.id as id FROM #__categories AS cat JOIN #__categories AS parent ';
		$subquery .= 'ON cat.lft BETWEEN parent.lft AND parent.rgt ';
		$subquery .= 'WHERE parent.extension = ' . $db->quote('com_amazons3');
		$subquery .= ' AND parent.published <= 0 GROUP BY cat.id';
		
		$db->setQuery($subquery);
		if($result = $db->loadColumn())
		{
			$badcats = $result;
		}
		else
		{
			$badcats = array();
		}
		
		return $badcats;
		
	}
	


}

?>