<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");
 
/**
 * File item view class.
 *
 * @package     Amazons3
 * @subpackage  Views
 */
class Amazons3ViewFile extends JViewLegacy
{
	protected $item;
	protected $form;
	protected $state;
	
	public function display($tpl = null)
	{
		$this->state 	= $this->get('State');
		$this->item 	= $this->get('Item');
		//$this->form 	= $this->get('Form');
		$this->params = $this->state->get("params");

		$app = JFactory::getApplication();
		$user = JFactory::getUser();
		$levels = $user->getAuthorisedViewLevels();
		
		// Check if item is empty
		if (empty($this->item))
		{
			//$app->redirect(JRoute::_('index.php?option=com_amazons3&view=files'), JText::_('JERROR_NO_ITEMS_SELECTED'));
			JError::raiseError(404, JText::_('COM_AMAZONS3_ERROR_FEED_NOT_FOUND'));
		}
		
	/*	// Check item access
		if ($this->item->id && !in_array($this->item->access, $levels))
		{
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
		}*/
		
		if($this->item->params->get('package-access-view') == false)
		{
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
			return;
		}
			
		// Is the user allowed to create an item?
		if (!$this->item->id && !$user->authorise("core.create", "com_amazons3"))
		{
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
		}


		// Check the view access to the article (the model has already computed the values).
		if ($this->item->params->get('access-view') == false && ($this->params->get('no_access_files', 'show') == 'hide'))
		{
			JError::raiseWarning(403, JText::_('JERROR_ALERTNOAUTHOR'));

			return;
		}

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors));
			return false;
		}		

		// Increment hits
		//$model = $this->getModel();
		//$model->hit($this->item->id);
		
		parent::display($tpl);
	}
}
?>