<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

// necessary libraries
JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('dropdown.init');
JHtml::_('formbehavior.chosen', 'select');

// sort ordering and direction
$listOrder = $this->state->get('list.ordering');
$listDirn = $this->state->get('list.direction');
$user = JFactory::getUser();
$show_no_access = ($this->params->get("no_access_files","show") == "show");
?>
<style>
.row2 {
	background-color: #e4e4e4;
}
</style>

<h2><?php echo JText::_('COM_AMAZONS3_AMAZONS3_PACKAGES_FILES_VIEW_FILES_TITLE'); ?></h2>
<form action="<?php JRoute::_('index.php'); ?>" method="post" name="adminForm" id="adminForm">
	<?php
		// Search tools bar
		echo JLayoutHelper::render('joomla.searchtools.default', array('view' => $this));
	?>
	<?php if ($this->params->get('show_pagination_limit',1)) : ?>
    <div class="btn-group pull-right">
        <label for="limit" class="element-invisible">
            <?php echo JText::_('JGLOBAL_DISPLAY_NUM'); ?>
        </label>
        <?php echo $this->pagination->getLimitBox(); ?>
    </div>
   <?php endif; ?>
    
	<table class="category table table-striped table-bordered table-hover">	
		<thead>
			<tr>
				<th id="itemlist_header_title">
					<?php echo JHtml::_('grid.sort', 'JGLOBAL_TITLE', 'a.title', $listDirn, $listOrder); ?>
				</th>
                <th class="nowrap left">&nbsp;
                  
                </th>
				<th class="nowrap left">
					<?php echo JHtml::_('grid.sort', JText::_('COM_AMAZONS3_AMAZONS3_PACKAGES_FILES_FIELD_PACKAGE_LABEL'), 'a.package', $listDirn, $listOrder) ?>
				</th>
				<th class="nowrap left">
					<?php echo JHtml::_('grid.sort', JText::_('COM_AMAZONS3_AMAZONS3_PACKAGES_FILES_FIELD_FILE_VERSION_LABEL'), 'a.file_version', $listDirn, $listOrder) ?>
				</th>
				<?php if ($this->params->get('list_show_author', 1)) : ?>
				<th id="itemlist_header_author">
					<?php echo JHtml::_('grid.sort', 'JAUTHOR', 'author', $listDirn, $listOrder); ?>
				</th>
				<?php endif; ?>
				<?php if ($this->params->get('list_show_hits', 1)) : ?>
				<th id="itemlist_header_hits">
					<?php echo JHtml::_('grid.sort', 'JGLOBAL_HITS', 'a.hits', $listDirn, $listOrder); ?>
				</th>
				<?php endif; ?>
			</tr>
		</thead>		
		<tbody>
		<?php foreach ($this->items as $i => $item) :
		?>
			<tr class="row<?php echo $i % 2; ?>">
				<td headers="itemlist_header_title" class="list-title">
					<?php if ($item->params->get("access-view",false) || $show_no_access ) : ?>
						<a href="<?php echo JRoute::_("index.php?option=com_amazons3&view=file&id=" . (int)$item->id); ?>">
							<?php echo $this->escape($item->title); ?>
						</a><br />
					<?php else: ?>
						<?php echo $this->escape($item->title); ?>
					<?php endif; ?>
				</td>
                <td>
					<?php if ($item->params->get("access-view",false)) : ?>
                        <a class="btn" href="<?php echo JRoute::_('index.php?option=com_amazons3&task=file.download&code='.$this->escape($item->code)); ?>"><?php echo JText::_("COM_AMAZONS3_DOWNLOAD"); ?></a>                       
					<?php else: ?>
						<?php echo JText::_("AMAZONS3_DOWNLOAD_RESTRICTED"); ?>
					<?php endif; ?>
                </td>
				<td><?php echo $this->escape($item->package_title); ?></td>
				<td><?php echo $this->escape($item->file_version); ?></td>
				<?php if ($this->params->get('list_show_author', 1)) : ?>
				<td class="small hidden-phone">
					<?php echo $this->escape($item->author_name); ?>
				</td>
				<?php endif; ?>
				<?php if ($this->params->get('list_show_hits', 1)) : ?>
				<td headers="itemlist_header_hits" class="list-hits">
					<span class="badge badge-info">
						<?php echo JText::sprintf('JGLOBAL_HITS_COUNT', (int)$item->hits); ?>
					</span>
				</td>
				<?php endif; ?>
			</tr>
		<?php endforeach ?>
		</tbody>		
		<tfoot>
			<tr>
				<td colspan="6">
				<?php if (($this->params->def('show_pagination', 1) == 1 || ($this->params->get('show_pagination') == 2)) && ($this->pagination->get('pages.total') > 1)) : ?>
                    <div class="pagination">
                        <?php if ($this->params->def('show_pagination_results', 1)) : ?>
                            <p class="counter pull-right"> <?php echo $this->pagination->getPagesCounter(); ?> </p>
                        <?php endif; ?>
                        <?php echo $this->pagination->getPagesLinks(); ?> 
                    </div>
                <?php endif; ?>             
                
                </td>
			</tr>
		</tfoot>	
	</table>
	<div>
		<input type="hidden" name="task" value=" " />
		<input type="hidden" name="boxchecked" value="0" />
		<!-- Sortierkriterien -->
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
	</div>
</form>