<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

/**
 * Files list view class.
 *
 * @package     Amazons3
 * @subpackage  Views
 */
class Amazons3ViewFiles extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;
	protected $toolbar;

	public function display($tpl = null)
	{
		$app = JFactory::getApplication();
		
		$this->items 		 = $this->get('Items');
		$this->state 		 = $this->get('State');
		$this->pagination 	 = $this->get('Pagination');
		$this->user		 	 = JFactory::getUser();
		$this->filterForm    = $this->get('FilterForm');
		$this->activeFilters = $this->get('ActiveFilters');
		
		$this->params = $this->state->get("params");
		
		// Prepare the data.
		foreach ($this->items as $item)
		{
			$item->slug	= $item->alias ? ($item->id.':'.$item->alias) : $item->id;

			$temp = new JRegistry;
			$temp->loadString($item->params);
				
			$item->params = clone($this->params);
			$item->params->merge($temp);//item params (stored in temp) take priority
		}

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors));
			return false;
		}
		
		if ($this->getLayout() == 'button')
		{
			if ($this->user->authorise('core.edit', "com_amazons3")||$this->user->authorise('core.create', "com_amazons3"))
			{						
				JHTML::_('behavior.framework',true);
				$input = JFactory::getApplication()->input;
				$eName = $input->getCmd('e_name');
				$eName    = preg_replace('#[^A-Z0-9\-\_\[\]]#i', '', $eName);
				
				$this->asset = $input->getCmd('asset');
				$this->author = $input->getCmd('author');
				$this->packagesLink = 'index.php?option=com_amazons3&amp;view=packages&amp;layout=button&amp;tmpl=component&amp;e_name=' . $eName . '&amp;asset=' . $this->asset . '&amp;author=' . $this->author;
				
				$document = JFactory::getDocument();
				$document->setTitle(JText::_('COM_AMAZONS3_BUTTON_DOC_TITLE'));
				
				$this->eName = &$eName;
				parent::display($tpl);
			}
			return;
		}
		
		
		parent::display($tpl);
	}
}
?>