<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");
 
/**
 * Package item view class.
 *
 * @package     Amazons3
 * @subpackage  Views
 */
class Amazons3ViewPackage extends JViewLegacy
{
	protected $item;
	protected $form;
	protected $state;
	
	public function display($tpl = null)
	{
		$this->state 	= $this->get('State');
		$this->item 	= $this->get('Item');

		$app = JFactory::getApplication();
		$this->params = $app->getParams();
		
		// Check if item is empty
		if (empty($this->item))
		{
			//$app->redirect(JRoute::_('index.php?option=com_amazons3&view=packages'), JText::_('JERROR_NO_ITEMS_SELECTED'));
			JError::raiseError(404, JText::_('COM_AMAZONS3_ERROR_FEED_NOT_FOUND'));
		}
		
		// Check item access
		if ($this->item->id && !$this->item->params->get('access-view',false))
		{
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
			return;
		}
			
		// Is the user allowed to create an item?
		if (!$this->item->id && !$user->authorise("core.create", "com_amazons3"))
		{
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
			return;
		}


		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors));
			return false;
		}		

		// Increment hits
		//$model = $this->getModel();
		//$model->hit($this->item->id);
		
		$filesModel = $this->getModel("files");
		$filesState = $filesModel->getState();
		$filesState->set('filter.package',$this->item->id);
		$this->item->files = $filesModel->getItems();
		
		parent::display($tpl);
	}
}
?>