<?php
/**
 * @author Fiona Coulter		
 * @copyright Spiral Scripts
 * @license GPL		
 */

defined("_JEXEC") or die("Restricted access");

/**
 * Packages list view class.
 *
 * @package     Amazons3
 * @subpackage  Views
 */
class Amazons3ViewPackages extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;
	protected $toolbar;

	public function display($tpl = null)
	{
		$app = JFactory::getApplication();
		
		$this->items 		 = $this->get('Items');
		$this->state 		 = $this->get('State');
		$this->pagination 	 = $this->get('Pagination');
		$this->user		 	 = JFactory::getUser();
		$this->filterForm    = $this->get('FilterForm');
		$this->activeFilters = $this->get('ActiveFilters');
		
		
		$this->params = $this->state->get("params");
		// Prepare the data.
		foreach ($this->items as $item)
		{
			$item->slug	= $item->alias ? ($item->id.':'.$item->alias) : $item->id;

			$temp = new JRegistry;
			$temp->loadString($item->params);
				
			$item->params = clone($this->params);
			$item->params->merge($temp); //gives priority to the item params in temp
		}

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors));
			return false;
		}
		
		if ($this->getLayout() == 'button')
		{
			if ($this->user->authorise('core.edit', "com_amazons3")||$this->user->authorise('core.create', "com_amazons3"))
			{
  
			  $lang = JFactory::getLanguage();
			  $lang->load('com_amazons3', JPATH_ADMINISTRATOR, null, false, true)
			  ||	$lang->load('com_amazons3', JPATH_SITE, null, false, true);
			  
			  JHTML::_('behavior.framework',true);
			  $input = JFactory::getApplication()->input;
			  $eName = $input->getCmd('e_name');
			  $eName    = preg_replace('#[^A-Z0-9\-\_\[\]]#i', '', $eName);
			  
				$this->asset = $input->getCmd('asset');
				$this->author = $input->getCmd('author');
				$this->filesLink = 'index.php?option=com_amazons3&amp;view=files&amp;layout=button&amp;tmpl=component&amp;e_name=' . $eName . '&amp;asset=' . $this->asset . '&amp;author=' . $this->author;
			  
			  
			  $document = JFactory::getDocument();
			  $document->setTitle(JText::_('COM_AMAZONS3_BUTTON_DOC_TITLE'));
			  
			  $this->eName = &$eName;
			  parent::display($tpl);
			}
			return;
		}
		
		
		parent::display($tpl);
	}
}
?>