<?php
/*
copyright 2009 Fiona Coulter http://www.iswebdesign.co.uk

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

*/


// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

JModelLegacy::addIncludePath(JPATH_SITE . '/components/com_amazons3/models', 'Amazons3Model');


class PlgContentAs3 extends JPlugin
{
	
	 protected static $layouts = array();
	
	 function onContentPrepare($context,&$row, &$contentParams, $page=0)
	 {
		  $app = JFactory::getApplication();
		  if($app->isAdmin())
		  {
			  return;
		  }
		 
		  
		  if(JPluginHelper::isEnabled('content','as3')==false) return;
		  $pluginParams = $this->params;
		  $entry_text = $row->text ;
		  
		  $param_defaults = array('package'=>'', 'file'=>'');
		  $permittedKeys = array_keys($param_defaults);
		  
		  
		  if( preg_match_all( "/{as3:(.*?)}/i", $entry_text, $matches, PREG_SET_ORDER ) > 0 ) {
			  
			$renderPlugin = true;
			$i=0;
			$lang = JFactory::getLanguage();
			$lang->load("com_amazons3");
			
			foreach( $matches as $match)//loop through plugin occurances
			{	
			
			    $replace_text = '';
				
				if(isset($match[1])){
					$user_params = $this->get_params($match[1], $param_defaults, $permittedKeys);
				}
				else
				{
					$user_params = $param_defaults;
				}
				
				if(!empty($user_params["package"]))
				{
					$replace_text = $this->getPackageByCode($user_params["package"]);
				}
				else if(!empty($user_params["file"]))
				{
					$replace_text = $this->getFileByCode($user_params["file"]);
					
				}
				
				$findtext = $match[0];
		        $entry_text = str_replace($findtext, $replace_text, $entry_text);
				
			} //end foreach $matches as $match
			 
			 $row->text = $entry_text; //this is correct because earlier we set $entry_text = $row->text

			  
		  }//end if preg_match_all
		   



	 }
	 
	function get_params( &$match, $param_defaults, $permittedKeys ) {
		$match = str_ireplace($permittedKeys,$permittedKeys, $match); //make case insensitive
		//$match = str_ireplace(' ','',$match); don't do this
		$match = trim($match);
	    $params_init = $param_defaults;
		$params = explode( ";", $match ) ;
		foreach( $params as $param ) {
			$param = explode( "=", $param ) ;
			$param[0] = trim($param[0]);
			if(isset($param[1]))
			{
				$param[1] = trim($param[1]);
			}
			
			if( (isset( $params_init[$param[0]] ) && in_array($param[0],$permittedKeys)) ) {
				$params_init[$param[0]] = html_entity_decode($param[1]) ;
			}
		}
		return $params_init ;
	}
	
	public function getPackageByCode($code)
	{
		//gets the html output for the package download links
		
		//return "package code = ".$code;
		
		$model = JModelLegacy::getInstance('Package', 'Amazons3Model', array('ignore_request' => true));
		$model->setState("package.code",$code);
		$params = JComponentHelper::getParams("com_amazons3");
		$model->setState('params', $params);
		
		$no_access_files = $params->get("no_access_files","show");
		
		if($package = $model->getItem())
		{
			if(!$package->params->get("access-view"))
			{
				return JText::_('PLG_AMAZONS3_PACKAGE_ACCESS_RESTRICTED');
			}
			
		   $filesModel = JModelLegacy::getInstance('Files', 'Amazons3Model', array('ignore_request' => true));
		   $filesModel->setState('filter.package', $package->id);
		   $filesModel->setState("no_access_files", $no_access_files);
		   $filesModel->setState("params",$params);
		   $package->files = $filesModel->getItems();
		   
		   $tmplPath = $this->getLayoutPath("package");
		   $view = new stdClass();
		   $view->package = $package;
		   
		   $html = $this->getOutput($view, $tmplPath);
		   return $html;
			
			
		}
		else
		{
		  //return JText::_('PLG_AMAZONS3_PACKAGE_NOT_FOUND').' '.htmlspecialchars($code);	
		  return "";
		  
		}


		
	}
	
	public function getFileByCode($code)
	{
		$model = JModelLegacy::getInstance('File', 'Amazons3Model', array('ignore_request' => true));
		$model->setState("file.code",$code);
		$params = JComponentHelper::getParams("com_amazons3");
		$model->setState('params', $params);
		
		if($item = $model->getItem())
		{
			$tmplPath = $this->getLayoutPath("file");
			$view = new stdClass();
			$view->item = $item;
			$html = $this->getOutput($view, $tmplPath);
			return $html;
			
		}
		else
		{
		  return "";
		}
		
		
		
		
	}
	
	protected function getLayoutPath($layout)
	{
		$file = basename($layout);
		if(isset(self::$layouts[$file]))
		{
			return self::$layouts[$file];
		}
		
		$pluginName = "as3";
		
		$layoutPath = JPATH_SITE.'/plugins/content/'.$pluginName.'/tmpl/'.$file.'.php';
		if(!file_exists($layoutPath))
		{
		  return false;	
		}
		
		$app = JFactory::getApplication();
		if(file_exists(JPATH_SITE.'/templates/'.$app->getTemplate().'/html/'.$pluginName.'/plugins/content/'.$file.'.php')){
			$filepath = JPATH_SITE.'/templates/'.$app->getTemplate().'/html/'.$pluginName.'/plugins/content/'.$file.'.php';
		} 
		else 
		{
			$filepath = $layoutPath;
		}
		self::$layouts[$file] = $filepath;
		
        return $filepath;
		
		
	}
	

	protected function getOutput($view, $tmpl)
	{
		ob_start();
		include($tmpl);
		$output = ob_get_contents();
		ob_end_clean();
		return $output;		
		
	}

	 
	 
}
