<?php
/*
copyright 2015 Fiona Coulter http://www.iswebdesign.co.uk

This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

defined('_JEXEC') or die;

class PlgButtonAs3downloads extends JPlugin
{
	protected $autoloadLanguage = true;

	/**
	 * Display the button.
	 *
	 * @param   string   $name    The name of the button to display.
	 * @param   string   $asset   The name of the asset being edited.
	 * @param   integer  $author  The id of the author owning the asset being edited.
	 *
	 * @return  array    A two element array of (resultName, textToInsert) or false if not authorised.
	 */
	 
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
	 
	 
	public function onDisplay($name, $asset, $author)
	{
		$app = JFactory::getApplication();
		$user = JFactory::getUser();
		$asset = $app->input->get('option');
		$extension = "com_amazons3";

		if ($asset == '')
		{
			$asset = $extension;
		}

		if (($user->authorise('core.edit', $extension)||$user->authorise('core.create', $extension))
				&& 	($user->authorise('core.edit', $asset)||$user->authorise('core.create', $asset)) )
		{
			$link = 'index.php?option=com_amazons3&amp;view=packages&amp;layout=button&amp;tmpl=component&amp;e_name=' . $name . '&amp;asset=' . $asset . '&amp;author=' . $author;
			JHtml::_('behavior.modal');
			$button = new JObject;
			$button->modal = true;
			$button->class = 'btn';
			$button->link = $link;
			$button->text = JText::_('PLG_AS3_BUTTON_PACKAGE');
			$button->name = 'amazons3';
			$button->options = "{handler: 'iframe', size: {x: 800, y: 500}}";

			return $button;
		}
		else
		{
			return false;
		}
	}
}
